<#
la bible : http://www.pinvoke.net/default.aspx/kernel32.EnumResourceNames
http://blog.kalmbachnet.de/?postid=26
https://msdn.microsoft.com/en-us/library/ms648008(v=vs.85).aspx#_win32_Creating_a_Resource_List
http://www.codeproject.com/Questions/542083/EnumResourceTypesplusenumeratesplusonlyplusMUIplus

https://msdn.microsoft.com/en-us/library/ms648008(v=vs.85).aspx#_win32_Updating_Resources
The following example copies a dialog box resource from one executable file, Hand.exe, to another, Foot.exe, by following these steps: 
1.Use the LoadLibrary function to load the executable file Hand.exe. 
2.Use the FindResource and LoadResource functions to locate and load the dialog box resource. 
3.Use the LockResource function to retrieve a pointer to the dialog box resource data. 
4.Use the BeginUpdateResource function to open an update handle to Foot.exe. 
5.Use the UpdateResource function to copy the dialog box resource from Hand.exe to Foot.exe. 
6.Use the EndUpdateResource function to complete the update.
#>

# getlasterror : 
#https://blogs.technet.microsoft.com/heyscriptingguy/2013/06/25/use-powershell-to-interact-with-the-windows-api-part-1/
#https://blogs.technet.microsoft.com/heyscriptingguy/2013/06/27/use-powershell-to-interact-with-the-windows-api-part-3/
#http://powershell.com/cs/media/p/40625.aspx
param(
    [Parameter(Mandatory=$true)][string] $src,
    [string] $dst,
    [switch] $FlgModif= $false)

# on numre dst
if ($dst -eq "" -and $FlgModif -eq $false){
    $dst = $src
}

# la ressource  modifier
$typeRes               = 'UIFILE'
[IntPtr]$intptrNameRes = 1001
[UInt16]$ushortLang    = 1033

$code = @"
using System;
using System.Runtime.InteropServices;       // pour DllImport
using System.Text;
using System.ComponentModel;                // pour Win32Exception

namespace ns_ModifyResource{
    public class c_ModifyResource {

#region LoadLibraryEx/FreeLibrary

        public enum LoadLibraryFlags : uint {
            DONT_RESOLVE_DLL_REFERENCES = 0x00000001,
            LOAD_IGNORE_CODE_AUTHZ_LEVEL = 0x00000010,
            LOAD_LIBRARY_AS_DATAFILE = 0x00000002,
            LOAD_LIBRARY_AS_DATAFILE_EXCLUSIVE = 0x00000040,
            LOAD_LIBRARY_AS_IMAGE_RESOURCE = 0x00000020,
            LOAD_WITH_ALTERED_SEARCH_PATH = 0x00000008
        }

       // ??? If you only want to load resources from the library, specify LoadLibraryFlags.LoadLibraryAsDatafile as dwFlags. In this case, nothing is done to execute or prepare to execute the mapped file.
        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern IntPtr LoadLibraryEx(
            string lpFileName, 
            IntPtr hReservedNull, 
            LoadLibraryFlags dwFlags);

        [DllImport("kernel32.dll", SetLastError=true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool FreeLibrary(
            IntPtr hModule);
#endregion  LoadLibraryEx/FreeLibrary

#region les signatures de FindResource 
        [DllImport("kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResource(IntPtr hModule, IntPtr lpName, IntPtr lpType);

        [DllImport( "kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResource(IntPtr hModule, string lpName, IntPtr lpType);

        [DllImport( "kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResource(IntPtr hModule, IntPtr lpName, string lpType);

        [DllImport( "kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResource(IntPtr hModule, string lpName, string lpType);
#endregion les signatures de FindResource 

#region les signatures de FindResourceEx 
        [DllImport("kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResourceEx(IntPtr hModule, IntPtr lpName, IntPtr lpType, ushort wLanguage);

        [DllImport( "kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResourceEx(IntPtr hModule, string lpName, IntPtr lpType, ushort wLanguage);

        [DllImport( "kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResourceEx(IntPtr hModule, IntPtr lpName, string lpType, ushort wLanguage);

        [DllImport( "kernel32.dll", CharSet = CharSet.Unicode, SetLastError=true)]
        public static extern IntPtr FindResourceEx(IntPtr hModule, string lpName, string lpType, ushort wLanguage);
#endregion les signatures de FindResourceEx

        [DllImport("kernel32.dll", SetLastError=true)]
        public static extern IntPtr LoadResource(IntPtr hModule, IntPtr hResInfo);

        [DllImport("kernel32.dll", SetLastError=true)]
        public static extern IntPtr LockResource(IntPtr hResData);

        [DllImport("kernel32.dll", SetLastError=true)]
        public static extern uint SizeofResource(IntPtr hModule, IntPtr hResInfo);

#region Modification d'une Resource
        [DllImport("kernel32.dll", SetLastError=true)]
        public static extern IntPtr BeginUpdateResource(string pFileName,
            [MarshalAs(UnmanagedType.Bool)]bool bDeleteExistingResources);

        [DllImport("kernel32.dll", SetLastError=true)]
        //public static extern bool UpdateResource(IntPtr hUpdate, IntPtr lpType, IntPtr lpName, ushort wLanguage, IntPtr lpData, uint cbData);
        public static extern bool UpdateResource(IntPtr hUpdate, String lpType, IntPtr lpName, ushort wLanguage, String lpData, int cbData);

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool EndUpdateResource(IntPtr hUpdate, bool fDiscard);

#endregion Modification d'une Resource

#region Equivalent des Macro
        private static bool IS_INTRESOURCE(IntPtr value)
        {
            if ( ((long) value) > ((long) ushort.MaxValue))
                return false;
            return true;
        }
        private static uint GET_RESOURCE_ID(IntPtr value)
        {
            if (IS_INTRESOURCE(value) == true)
                return (uint) value;
            throw new System.NotSupportedException("value is not an ID!");
        }
        private static string GET_RESOURCE_NAME(IntPtr value)
        {
            if (IS_INTRESOURCE(value) == true)
                return value.ToString();
            return Marshal.PtrToStringUni((IntPtr) value);
        }
#endregion Equivalent des Macro

#region Enumration des langues des ressources
        [DllImport("kernel32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
        static extern bool EnumResourceLanguages(IntPtr hModule, IntPtr lpszType,
            IntPtr lpName, EnumResLangDelegate lpEnumFunc, IntPtr lParam);

        private delegate bool EnumResLangDelegate(
            IntPtr hModule, 
            IntPtr lpszType, 
            IntPtr lpszName, 
            ushort wIDLanguage, 
            IntPtr lParam);

        private static bool EnumResLangCallback(
            IntPtr hModule, 
            IntPtr lpszType, 
            IntPtr lpszName, 
            ushort wIDLanguage, 
            IntPtr lParam)
        {
            Console.WriteLine("\t\tLanguage: {0}", wIDLanguage);
            return true;
        }

#endregion Enumration des langues des ressources

#region Enumration des noms des ressources
        [DllImport("kernel32.dll",
            CharSet = CharSet.Unicode, SetLastError = true)]
        static extern bool EnumResourceNames(
            IntPtr hModule,
            IntPtr lpszType,
            EnumResourceNameDelegate lpEnumFunc,
            IntPtr lParam);

        private delegate bool EnumResourceNameDelegate(
            IntPtr hModule,
            IntPtr lpszType,
            IntPtr lpszName,
            IntPtr lParam);

        static bool EnumResourceNameCallback(
            IntPtr hModule,
            IntPtr lpszType,
            IntPtr lpszName,
            IntPtr lParam)
        {
            Console.WriteLine("\tName: {0}", GET_RESOURCE_NAME(lpszName));
            bool bret = EnumResourceLanguages(hModule, lpszType,
                lpszName, new EnumResLangDelegate(EnumResLangCallback), lParam);
            if (bret == false)
            {
                throw new Win32Exception(Marshal.GetLastWin32Error());
            }

            return true;
        }

        private delegate bool EnumResourceTypesDelegate(
            IntPtr hModule, 
            IntPtr lpszType,
            long lParam);
#endregion Enumration des noms des ressources

#region Enumration des types des ressources
        [DllImport("kernel32",CharSet = CharSet.Unicode, SetLastError = true)]
        private extern static long EnumResourceTypes(IntPtr hModule, EnumResourceTypesDelegate callback, long lParam);

        // Implement required logic in EnumResourceTypesCallback function. Return 0 to stop enumeration, 1 to continue enumeration.  
        static bool EnumResourceTypesCallback(IntPtr hModule, IntPtr lpszType, long lParam)
        {
            if (IS_INTRESOURCE(lpszType))
            {
                Console.WriteLine("Type : {0}",GET_RESOURCE_ID(lpszType));
            }
            else
            {
                Console.WriteLine("Type : {0}",GET_RESOURCE_NAME(lpszType));
            }

            if (EnumResourceNames(hModule, lpszType,
                new EnumResourceNameDelegate(EnumResourceNameCallback), IntPtr.Zero) == false)
            {
                Console.WriteLine("erreur: {0}", Marshal.GetLastWin32Error());
            }
            return true;
        }

        // appel depuis powershell. set hModule and lParam to required values).
        public static void MyEnumResources(IntPtr hModule) {
            long lParam = 0;
            EnumResourceTypes(hModule, new EnumResourceTypesDelegate(EnumResourceTypesCallback), lParam);
        }
#endregion Enumration des types des ressources

    } // end class
} // end namespace
"@
if (-not ("ns_ModifyResource.c_ModifyResource" -as [Type]))
{
    Add-Type  -TypeDefinition $code 
}

#
# on numre les types, noms, langues
#
if ( -not $FlgModif){
    "On numre les ressources de : $dst"
    # chargement du programme src LOAD_LIBRARY_AS_DATAFILE ?
    [System.IntPtr] $moduleHandle = [ns_ModifyResource.c_ModifyResource]::LoadLibraryEx($dst, [IntPtr]0, [ns_ModifyResource.c_ModifyResource+LoadLibraryFlags]::LOAD_LIBRARY_AS_DATAFILE);
    [ns_ModifyResource.c_ModifyResource]::MyEnumResources($moduleHandle)
    [ns_ModifyResource.c_ModifyResource]::FreeLibrary($moduleHandle)
    return
}

# copie du fichier
[system.io.File]::Copy($src, $dst, $true);

# chargement du programme src LOAD_LIBRARY_AS_DATAFILE ?
[System.IntPtr] $moduleHandle = [ns_ModifyResource.c_ModifyResource]::LoadLibraryEx($dst, [IntPtr]0, [ns_ModifyResource.c_ModifyResource+LoadLibraryFlags]::LOAD_LIBRARY_AS_DATAFILE);

#
# on cherche la ressource UIFILE : 1001 : 1033
#
#[System.IntPtr] $hResource = [ns_ModifyResource.c_ModifyResource]::FindResource($moduleHandle, $intptrNameRes, $typeRes);
#if ($hResource -eq 0) {
#    throw ( New-Object ComponentModel.Win32Exception )
#}
[System.IntPtr] $hResource = [ns_ModifyResource.c_ModifyResource]::FindResourceEx($moduleHandle, $typeRes, $intptrNameRes, $ushortLang);
if ($hResource -eq 0) {
    throw ( New-Object ComponentModel.Win32Exception )
}

#
# on charge la ressource
#
[System.IntPtr] $hResData = [ns_ModifyResource.c_ModifyResource]::LoadResource($moduleHandle, $hResource)

#
# on verrouille en mmoire
#
[System.IntPtr] $pointeur = [ns_ModifyResource.c_ModifyResource]::LockResource($hResData)

#
# taille de la ressource
#
$taille = [ns_ModifyResource.c_ModifyResource]::SizeofResource($moduleHandle, $hResource)

#
# on copie le texte de la ressource dans un buffer
#
#    byte[] y = new byte[resSize];
[ byte[]] $y = new-object byte[] $taille
#
#    Marshal.Copy(pResource, y, 0, (int)resSize);
# http://poshcode.org/3859
[Runtime.InteropServices.Marshal]::Copy($pointeur, $y, 0, $taille)
#
#    affichage du texte de la ressource
#
#https://social.technet.microsoft.com/Forums/fr-FR/29ea4847-6c1c-4d4e-9b8c-37508d0586ac/converting-a-byte-array-into-a-string-powershell?forum=ITCG
#[System.Text.Encoding]::Unicode.GetString($y)
# bizarre : la ressource est ascii et non unicode !
$texte = [System.Text.Encoding]::Ascii.GetString($y)

# dchargement du programme
[ns_ModifyResource.c_ModifyResource]::FreeLibrary($moduleHandle)

#
# on modifie le texte de la ressource
#
$template1 = 'shellexecute="ms-settings:personalization-background"'
$string1   = 'shellexecute="%windir%\\system32\\control.exe" shellexecuteparams=" /name Microsoft.Personalization /page pageWallpaper"'
if ( $($texte.contains($template1)) )
{
    $texte = $texte -replace $template1,$string1
}

$template2 = 'shellexecute="ms-settings:personalization-colors"'
$string2   = 'shellexecute="%windir%\\system32\\control.exe" shellexecuteparams=" /name Microsoft.Personalization /page pageColorization"'
if ( $($texte.contains($template2)) )
{
    $texte = $texte -replace $template2,$string2
}

#
# on modife la ressource dans le fichier copi
#

#       IntPtr handle = BeginUpdateResource(file, false);
[System.IntPtr] $handle = [ns_ModifyResource.c_ModifyResource]::BeginUpdateResource($dst, $false);
#        bool res = UpdateResource(handle, sType, sName, 1033, sbText, sbText.Length);
[bool] $bRes = [ns_ModifyResource.c_ModifyResource]::UpdateResource($handle, $typeRes, $intptrNameRes, $ushortLang, $texte, $($texte.Length));
#        EndUpdateResource(handle, false);
[ns_ModifyResource.c_ModifyResource]::EndUpdateResource($handle, $false);



